//#define _GLIBCXX_DEBUG

#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <utility>
#include <stack>
#include <queue>
#include <stdint.h>
#include <stdlib.h>
#include <set>
#include <cmath>
#include <set>
#include <limits.h>
using namespace std;

#define NAME "pencil"
typedef pair<int, int> pii;

#define MP(x, y) make_pair((x), (y))
#define X first
#define Y second

int n, k;

const int nmax = 100100;
bool used[nmax] = {};

int maxdis = INT_MAX;

inline bool cmp_byx(pair<pii, int> a, pair<pii, int> b)
{
    return a.X < b.X;
}

inline bool cmp_byy(pair<pii, int> a, pair<pii, int> b)
{
    pii l = a.X, r = b.X;

    if (l.Y < r.Y)
        return true;
    if (l.Y == r.Y && l.X < r.X)
        return true;
    return false;
}

void check(multiset<pii> & line)
{
    multiset<pii>::iterator b = line.begin(), e = line.end();
    --e;
    int val = e->X - b->X;
    if (maxdis > val)
        maxdis = val;
}

void show(multiset<pii> & line)
{
    for (auto x : line) {
        cout << x.first << ": " << x.second << "\n";
    }
    cout << "\n\n";
}

int main()
{
    freopen(NAME ".in", "r", stdin);
    freopen(NAME ".out", "w", stdout);
    multiset<pii> line;
    vector<pii> inp;
    vector<pair<pii, int> > byx, byy;

    scanf("%d%d", &n, &k);
    for (int i = 0; i < n; ++i) {
        int c, mn, mx, t;
        scanf("%d%d", &c, &t);
        if (c == 1) {
            inp.push_back(MP(t, t));
            byy.push_back(MP(MP(t, t), i));
            byx.push_back(MP(MP(t, t), i));
            continue;
        }
        mn = mx = t;
        for (int j = 1; j < c; ++j) {
            scanf("%d", &t);
            mn = min(t, mn);
            mx = max(t, mx);
        }
        inp.push_back(MP(mn, mx));
        byy.push_back(MP(MP(mn, mx), i));
        byx.push_back(MP(MP(mn, mx), i));
    }

    sort(byx.begin(), byx.end(), cmp_byx);
    sort(byy.begin(), byy.end(), cmp_byy);

    line.insert(MP(byx[0].X.X, byx[0].Y));
    line.insert(MP(byx[0].X.Y, byx[0].Y));
    used[byx[0].Y] = true;
    int yyi = 0;

    for (int i = 1; i < k; ) {
        if (!used[byy[yyi].second]) {
            line.insert(MP(byy[yyi].X.X, byy[yyi].Y));
            line.insert(MP(byy[yyi].X.Y, byy[yyi].Y));
            used[byy[yyi].second] = true;
            ++i;
        }
        yyi++;
    }
   //show(line);
    check(line);

    for (int i = k; i < n && yyi < n; ++i) {
        int id = line.begin()->Y;
        line.erase(MP(inp[id].first, id));
        line.erase(MP(inp[id].second, id));
        while (yyi < n) {
            if (!used[byy[yyi].second]) {
                line.insert(MP(byy[yyi].X.X, byy[yyi].Y));
                line.insert(MP(byy[yyi].X.Y, byy[yyi].Y));
                used[byy[yyi].second] = true;
                break;
            }
            yyi++;
        }
        check(line);
        //show(line);
    }

    printf("%d\n", maxdis);



    return 0;
}
