#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <utility>
#include <stack>
#include <queue>
#include <stdint.h>
#include <stdlib.h>
#include <climits>
#include <set>
using namespace std;

#define NAME "submarine"
#define MP(x, y) make_pair((x), (y))

const int cmax = 2010;
typedef pair<int, int> pii;

int mtx[cmax][cmax] = {};
int h, w;
int k;

int letter[27] = {};

char inpu[cmax];
/*
int vert_pref[cmax][cmax];
int hor_pref[cmax][cmax];
*/

int sum = 0;

int bodies[cmax] = {};
int tails[cmax] = {};

pii find_line(int line, int start)
{
    //int mx = INT_MIN;
    int l = start;
    while (l < w && mtx[line][l] < 0)
    {
        ++l;
    }
    int r = l;
    while (r < w && mtx[line][r] >= 0)
    {
        sum += mtx[line][r];
        ++r;
    }
    --r;
    if (l == w)
        return MP(-1, -1);
    return MP(l, r);
}

void find_body(int line, int pos)
{
    int up = line-1;
    int mx = 0;
    sum = 0;
    while (up >= 0)
    {
        sum += mtx[up][pos];
        mx = max(mx, sum);
        --up;
    }
    sum = mx;
    //return up-1;
}

void find_tail(int line, int pos)
{
    int mx1 = 0;
    sum = 0;
    find_body(line, pos);
    mx1 = sum;

    sum = 0;
    int down = line + 1;
    int mx2 = 0;
    while (down < h)
    {
        sum += mtx[down][pos];
        mx2 = max(mx2, sum);
        ++down;
    }
    sum = mx1+mx2;
}

void show(multiset<int>& s)
{
    for (auto x: s)
        cerr << x << " ";
    cerr << endl;
}

int check2(int line, int l, int r, int s)
{
    int mx = INT_MIN;

    if (l == r)
        return INT_MIN;

    /*fill(bodies, bodies+w, 0);
    for (int i = l; i < r; ++i)
    {
        sum = 0;
        find_body(line, i);
        bodies[i] = sum;
    }
    fill(tails, tails+w, 0);

    for (int i = l; i <= r; ++i)
    {
        sum = 0;
        find_tail(line, i);
        tails[i] = sum;
    }
*/
    set<pair<int, int> > va1, va2;

    for (int i = l; i <= r; ++i)
        va2.insert(MP(tails[i], i));
   //show(va2);
    for (int i = l; i < r; ++i)
    {
        va1.insert(MP(bodies[i], i));
        va2.erase(MP(tails[i], i));
        set<pair<int, int> >::iterator i1 = va1.end(), i2 = va2.end();
        --i1;
        --i2;
        //show(va2);
        mx = max(mx, i1->first + i2->first + s);
    }


    return mx;
}

int sum_line(int line, int l, int r)
{
    int s = 0;
    for (int i = l; i <= r; ++i)
    {
        s += mtx[line][i];
    }
    return s;
}

int check(int line)
{
    //pii cords = find_line(line, 0);
    int mx = INT_MIN;

    fill(bodies, bodies+w, 0);
    for (int i = 0; i < w; ++i)
    {
        sum = 0;
        find_body(line, i);
        bodies[i] = sum;
    }
    fill(tails, tails+w, 0);

    for (int i = 0; i < w; ++i)
    {
        sum = 0;
        find_tail(line, i);
        tails[i] = sum;
    }

    for (int l = 0; l < w; ++l)
    {
        for (int r = l+1; r < w; ++r) {
            sum = 0;
            mx = max(mx, check2(line, l, r, sum_line(line, l, r)));
            /*if (mx == 22) {
                continue;
            }*/
        }
    }
    return mx;
}


int main()
{
    freopen(NAME ".in", "r", stdin);
    freopen(NAME ".out", "w", stdout);

    memset(mtx, INT_MIN, cmax*cmax*4);

    scanf("%d", &k);
    for (int i = 0; i < k; ++i)
        scanf("%d", &letter[i]);
    scanf("%d%d ", &h, &w);

    for (int i = 0; i < h; ++i)
    {
        fgets(inpu, cmax,stdin);
        for (int j = 0; j < w; ++j)
            mtx[i][j] = letter[inpu[j] - 'a'];
    }

    int mx = INT_MIN;
    for (int i = 0; i < h; ++i)
    {
        mx = max(mx,  check(i));
    }
    /*if (mx == INT_MIN)
    {
        for (int i = 0; i < h; ++i)
        {
            for (int j = 0; j < w-1; ++j)
            {
                mx = max(mx, mtx[i][j] + mtx[i][j+1]);
            }
        }
    }*/
    printf("%d\n", mx);


    /*
        for (int i = 0; i < h; ++i)
        {
            hor_pref[i][0] = mtx[i][0];
            for (int j = 1; j < w; ++j) {
                hor_pref[i][j] = hor_pref[i][j-1] + mtx[i][j];
            }
        }
        for (int i = 0; i < w; ++i)
        {
            vert_pref[0][i] = mtx[0][i];
            for (int j = 1; j < h; ++j) {
                hor_pref[j][i] = vert_pref[j-1][i] + mtx[j][i];
            }
        }
    */



    return 0;
}
